/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel;

import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;

import org.zhiqim.kernel.constants.ZhiqimConstants;
import org.zhiqim.kernel.util.Strings;
import org.zhiqim.kernel.util.Validates;

public class ZhiqimBootLoader extends URLClassLoader
{
    private String name = "ZhiqimBootLoader";
    
    protected ZhiqimBootLoader(URL[] urls, ClassLoader parent)
    {
        super(urls, parent);
    }
    
    /**
     * 创建ZhiqimContextLoader
     * @param serviceId
     * @return
     * @throws Exception 
     */
    public ZhiqimContextLoader createContextClassLoader(String serviceId) throws Exception
    {
        String serviceContext = Global.getString(ZhiqimConstants.Z_CONTEXT, serviceId);
        if (Validates.isEmpty(serviceContext))
            return null;

        ZhiqimContextLoader contextLoader = new ZhiqimContextLoader(new URL[0], this);
        String[] filePaths = Strings.split(serviceContext, ",");
        for (String filePath : filePaths)
        {
            File item = new File(filePath);
            if (item == null || !item.exists()) 
                continue;

            String filepath = item.getCanonicalPath();
            contextLoader.addJarFile(filepath, false);
        }

        return contextLoader;
    }
    
    public String toString()
    {
        return name;
    }
}
