/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.control;

/**
 * 可配置接口定义，用于跨框架之间相互配置参数<br><br>
 * 举例：<br>
 * 1、ZhiqimHttpd的HttpRequest,HttpContext实现Configurable，并实现配置<br>
 * 2、ZhiqimORM的ORM类从request/context中读取配置的值<br>
 * 
 *
 * @version v1.0.0 @author zouzhigang 2018-11-29 新建与整理
 */
public interface Configurable
{
    /** 读取配置值 */
    public String getConfiguration();
}
