/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.control;

import java.util.List;

/**
 * 处理器适配成可执行对象，以便在Threader中处理时转换成Handler中处理
 *
 * @version v1.0.0 @author zouzhigang 2014-2-27 新建与整理
 */
class Eventee<E> implements Runnable
{
    private E event;
    private List<Eventer<E>> eventerList;
    
    public Eventee(E event, List<Eventer<E>> eventerList)
    {
        this.event = event;
        this.eventerList = eventerList;
    }
    
    public void run()
    {
        for (Eventer<E> eventer : eventerList)
        {//按注册顺序冒泡处理
            if (!eventer.process(event))
                break;
        }
    }

    public E getEvent()
    {
        return event;
    }

    public List<Eventer<E>> getEventerList()
    {
        return eventerList;
    }
    
    public int hasCode()
    {
        return event.hashCode();
    }
    
    public boolean equals(Object obj) 
    {
        if (obj == null)
            return false;
        
        if (!(obj instanceof Eventee<?>))
            return false;
        
        Eventee<?> other = (Eventee<?>)obj;
        if (other.event == null)
            return this.event == null;
        else
            return (other.event.equals(this.event));
    }
    
    public String toString()
    {
        return event.toString();
    }
}
