/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.extend;

import java.util.Map;
import java.util.TreeMap;

import org.zhiqim.kernel.annotation.AnAlias;
import org.zhiqim.kernel.annotation.AnNew;

/**
 * 定义一个TreeMap<String, Object>参数和结果对象，但不要求<K, V>，比Map在ZML中new时不需要指定泛型
 *
 * @version v1.0.0 @author zouzhigang 2016-10-25 新建与整理
 */
@AnAlias("TreeMapSV")
@AnNew
public class TreeMapSV<V> extends MapSV<V>
{
    public TreeMapSV()
    {
        instance = new TreeMap<>();
    }
    
    public TreeMapSV(String key, V value)
    {
        instance = new TreeMap<>();
        instance.put(key, value);
    }
    
    public TreeMapSV(Map<String, V> instance)
    {
        this.instance = new TreeMap<>(instance);
    }
    
    public TreeMapSV(TreeMap<String, V> instance)
    {
        this.instance = new TreeMap<>(instance);
    }
    
    public TreeMapSV(MapSV<V> instance)
    {
        this.instance = new TreeMap<>(instance.instance());
    }
    
    public TreeMapSV(TreeMapSV<V> instance)
    {
        this.instance = new TreeMap<>(instance.instance());
    }
}
