/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.model;

import org.zhiqim.kernel.Service;

/**
 * 生命周期接口定义<br><br>
 * 1、open方法， 开启<br>
 * 2、close方法，关闭<br>
 * 主要区别服务类 @see {@link Service}<br>
 *
 * @version v1.5.2 @author zouzhigang 2019-6-9 新建与整理
 */
public interface Lifecycle extends AutoCloseable
{
    /** 开启，支持返回false和抛异常两种 */
    public boolean open() throws Exception;
    
    /** 关闭，不抛异常 */
    public void close();
}
