/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.util;

import org.zhiqim.kernel.annotation.AnAlias;
import org.zhiqim.kernel.constants.HtmlConstants;

/**
 * HTML相关工具类
 *
 * @version v1.0.0 @author zouzhigang 2014-2-27 新建与整理
 */
@AnAlias("Htmlx")
public class Htmlx implements HtmlConstants
{
    /**
     * 显示HTML内容格式标签
     * 
     * @param charset 编码
     * @return <meta http-equiv="Content-Type" content="text/html; charset=${charset}">
     */
    public static String toContentType(String charset)
    {
        return "<meta http-equiv=\"Content-Type\" content=\"text/html; charset="+charset+"\">\r\n";
    }
    
    /**
     * 显示HTML标题标签
     * 
     * @param title 标题信息
     * @return <title>${title}</title>
     */
    public static String toTitle(String title)
    {
        return "<title>"+title+"</title>\r\n";
    }
    
    /**
     * 显示Form表单或href通过iframe调用
     * 
     * @return <iframe name="zCallFrame" style="display:none;"></iframe>
     */
    public static String toCallFrame()
    {
        return "<iframe name=\"zCallFrame\" style=\"display:none;\"></iframe>";
    }
}
