/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.util;

import java.io.IOException;
import java.nio.file.FileSystems;
import java.nio.file.WatchService;

import org.zhiqim.kernel.annotation.AnAlias;

/**
 * 监视文件路径工具类
 * 
 * @version v1.0.0 @author zouzhigang 2014-2-27 新建与整理
 */
@AnAlias("Watchs")
public class Watchs
{
    /**
     * 获取文件系统监视服务
     * 
     * @return  监视服务
     */
    public static WatchService getWatchService()
    {
        try
        {
            return FileSystems.getDefault().newWatchService();
        }
        catch (IOException e)
        {
            throw Asserts.exception("该系统不支持文件监视服务[%s]", e, e.getMessage());
        }
    }
}
